#include <bits/stdc++.h>

using namespace std;

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int n;
    cin >> n;
    
    vector<long long> a(n), b(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++) cin >> b[i];
    
    long long res = 0;
    
    for(int i = 0; i < n; i++) 
    {
        long long xorSum = 0;
        long long andSum = (1LL << 62) - 1; 
        
        for(int j = i; j < n; j++) 
        {
            xorSum ^= a[j];
            andSum &= b[j];
            
            long long br = xorSum * andSum;
            res = max(res, br);
            
            if(andSum == 0) break;
        }
    }
    cout << res;
    
    return 0;
}